unit Exampleu;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    ListBox1: TListBox;
    Path: TLabel;
    Regex: TLabel;
    Button1: TButton;
    Button2: TButton;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    GroupBox2: TGroupBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  FileDirX;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  Types : TdeTypeSet;
  Attrs : TdeAttrSet;
  SL    : TStringList;
  Res   : integer;
  SR    : TdeSearchRec;
begin
  Types := [];
  if CheckBox6.Checked then
    Include(Types, detFile);
  if CheckBox7.Checked then
    Include(Types, detDirectory);
  if Types = [] then begin
    CheckBox6.Checked := true;
    Include(Types, detFile);
  end;
  Attrs := [];
  if CheckBox1.Checked then
    Include(Attrs, deaNormal);
  if CheckBox2.Checked then
    Include(Attrs, deaAltered);
  if CheckBox3.Checked then
    Include(Attrs, deaReadOnly);
  if CheckBox4.Checked then
    Include(Attrs, deaHidden);
  if CheckBox5.Checked then
    Include(Attrs, deaSystem);
  if Attrs = [] then begin
    CheckBox1.Checked := true;
    Include(Attrs, deaNormal);
  end;
  SL := TStringList.Create;
  try
    Res := FindFirstEx(Edit1.Text, Edit2.Text, Types, Attrs, SR);
    while Res = 0 do begin
      SL.Add(SR.srName);
      Res := FindNextEx(SR);
    end;
    FindCloseEx(SR);
    ListBox1.Items.Assign(SL);
  finally
    SL.Free;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Close;
end;

end.
